#Nesta linha indicamos o diretorio onde faremos a leitura e escrita dos grafos
setwd("C:/Users/Dell/Google Drive/Mestrado ETG/Dissertao - Multiplex Networks/Ensaios de diversidade/Segundo teste/150")

#Leitura dos grafos no formato edgelist utilizando o pacote igraph

g <- graph(scan("Comercio_atacadista_de_mercadorias_em_geral.txt"), directed=FALSE,n=698)

v <- graph(scan("Comercio_varejista_de_bebidas.txt"), directed=FALSE,n=698)

f <- graph(scan("Comercio_varejista_de_doces,_balas,_bombons_e_semelhantes.txt"), directed=FALSE,n=698)

x <- graph(scan("Comercio_varejista_de_hortifrutigranjeiros.txt"), directed=FALSE,n=698)

t <- graph(scan("Comercio_varejista_de_laticinios_e_frios.txt"), directed=FALSE,n=698)

k <- graph(scan("Comercio_varejista_de_mercadorias_em_geral_com_predominancia_de_produtos_alimenticios.txt"), directed=FALSE,n=698)

b <- graph(scan("Comercio_varejista_de_produtos_alimenticios_em_geral_ou_especializado_em_produtos_alimenticios_nao_especificados_anteriormente.txt"), directed=FALSE,n=698)

s <- graph(scan("Comercio_varejista_de_produtos_farmaceuticos,_com_manipulacao_de_formulas.txt"), directed=FALSE,n=698)

l <- graph(scan("Comercio_varejista_de_produtos_farmaceuticos,_sem_manipulacao_de_formulas.txt"), directed=FALSE,n=698)

i <- graph(scan("Padaria_e_confeitaria_com_predominancia_de_revenda.txt"), directed=FALSE,n=698)


is_simple(g)
is_simple(simplify(g, remove.loops=FALSE))
is_simple(simplify(g, remove.multiple=FALSE))
is_simple(simplify(g))

write_graph(g,"testeWriteSLX.txt",format=c("edgelist"))

#j<-simplify(j, remove.multiple=TRUE,remove.loops=TRUE)

#write_graph(g,"testeWriteSLX.txt",format=c("edgelist"))

#Calculo da distancia por partes
#calculo da nodedistance dos grafos g e h
ndg<-nodedist(g)
ndv<-nodedist(v)
ndf<-nodedist(f)
ndx<-nodedist(x)
ndt<-nodedist(t)
ndk<-nodedist(k)
ndb<-nodedist(b)
nds<-nodedist(s)
ndl<-nodedist(l)
ndi<-nodedist(i)

#calculo da matriz de transicao dos grafos Camada 01 e Camada 02
tg<-mat.trans(g)
tv<-mat.trans(v)
tf<-mat.trans(f)
tx<-mat.trans(x)
tt<-mat.trans(t)
tk<-mat.trans(k)
tb<-mat.trans(b)
ts<-mat.trans(s)
tl<-mat.trans(l)
ti<-mat.trans(i)

#calculamos a distancia entre os grafos Camada 01 e Camada 02
#matrizDi<-Di(ndg,tg,ndv,tv,ndf,tf)

#calculamos a distancia entre os grafos g e h
matrizDi<-Di(ndg,tg,ndv,tv,ndf,tf,ndx,tx,ndt,tt,ndk,tk,ndb,tb,nds,ts,ndl,tl,ndi,ti)
matrizDi
write.table(matrizDi,file='MatrixDi.txt',sep='\t',na="",quote=FALSE)

#matrizDi<-Di(ndg,tg,ndf,tf)
#D=mean(matrizDi)
#matrizDi<-Di(ndv,tv,ndf,tf)
write.table(matrizDi,file='MatrixDi.txt',sep='\t',na="",quote=FALSE)
#D




#matrizDi<-Di(ndg,tg,ndv,tv)
#D=mean(matrizDi)
#write.table(matrizDi,file='MatrixDi.txt',sep='\t',na="",quote=FALSE)

#matrizDi<-Di(ndg,tg,ndf,tf)
#D=mean(matrizDi)
#write.table(matrizDi,file='MatrixDi.txt',sep='\t',na="",quote=FALSE)

#matrizDi<-Di(ndg,tg,ndk,tk)
#D=mean(matrizDi)
#write.table(matrizDi,file='MatrixDi.txt',sep='\t',na="",quote=FALSE)
#D

#Para calcular a diversidade do sistema
#definimos uma matriz de distancia 
a=Matrix(0,ncol=10,nrow=10)

a[1,2]<-mean(Di(ndg,tg,ndv,tv))
a[1,3]<-mean(Di(ndg,tg,ndf,tf))
a[1,4]<-mean(Di(ndg,tg,ndx,tx))
a[1,5]<-mean(Di(ndg,tg,ndt,tt))
a[1,6]<-mean(Di(ndg,tg,ndk,tk))
a[1,7]<-mean(Di(ndg,tg,ndb,tb))
a[1,8]<-mean(Di(ndg,tg,nds,ts))
a[1,9]<-mean(Di(ndg,tg,ndl,tl))
a[1,10]<-mean(Di(ndg,tg,ndi,ti))

a[2,1]<-mean(Di(ndv,tv,ndg,tg))
a[2,3]<-mean(Di(ndv,tv,ndf,tf))
a[2,4]<-mean(Di(ndv,tv,ndx,tx))
a[2,5]<-mean(Di(ndv,tv,ndt,tt))
a[2,6]<-mean(Di(ndv,tv,ndk,tk))
a[2,7]<-mean(Di(ndv,tv,ndb,tb))
a[2,8]<-mean(Di(ndv,tv,nds,ts))
a[2,9]<-mean(Di(ndv,tv,ndl,tl))
a[2,10]<-mean(Di(ndv,tv,ndi,ti))

a[3,1]<-mean(Di(ndf,tf,ndg,tg))
a[3,2]<-mean(Di(ndf,tf,ndv,tv))
a[3,4]<-mean(Di(ndf,tf,ndx,tx))
a[3,5]<-mean(Di(ndf,tf,ndt,tt))
a[3,6]<-mean(Di(ndf,tf,ndk,tk))
a[3,7]<-mean(Di(ndf,tf,ndb,tb))
a[3,8]<-mean(Di(ndf,tf,nds,ts))
a[3,9]<-mean(Di(ndf,tf,ndl,tl))
a[3,10]<-mean(Di(ndf,tf,ndi,ti))

a[4,1]<-mean(Di(ndx,tx,ndg,tg))
a[4,2]<-mean(Di(ndx,tx,ndv,tv))
a[4,3]<-mean(Di(ndx,tx,ndf,tf))
a[4,5]<-mean(Di(ndx,tx,ndt,tt))
a[4,6]<-mean(Di(ndx,tx,ndk,tk))
a[4,7]<-mean(Di(ndx,tx,ndb,tb))
a[4,8]<-mean(Di(ndx,tx,nds,ts))
a[4,9]<-mean(Di(ndx,tx,ndl,tl))
a[4,10]<-mean(Di(ndx,tx,ndi,ti))

a[5,1]<-mean(Di(ndt,tt,ndg,tg))
a[5,2]<-mean(Di(ndt,tt,ndv,tv))
a[5,3]<-mean(Di(ndt,tt,ndf,tf))
a[5,4]<-mean(Di(ndt,tt,ndx,tx))
a[5,6]<-mean(Di(ndt,tt,ndk,tk))
a[5,7]<-mean(Di(ndt,tt,ndb,tb))
a[5,8]<-mean(Di(ndt,tt,nds,ts))
a[5,9]<-mean(Di(ndt,tt,ndl,tl))
a[5,10]<-mean(Di(ndt,tt,ndi,ti))

a[6,1]<-mean(Di(ndk,tk,ndg,tg))
a[6,2]<-mean(Di(ndk,tk,ndv,tv))
a[6,3]<-mean(Di(ndk,tk,ndf,tf))
a[6,4]<-mean(Di(ndk,tk,ndx,tx))
a[6,5]<-mean(Di(ndk,tk,ndt,tt))
a[6,7]<-mean(Di(ndk,tk,ndb,tb))
a[6,8]<-mean(Di(ndk,tk,nds,ts))
a[6,9]<-mean(Di(ndk,tk,ndl,tl))
a[6,10]<-mean(Di(ndk,tk,ndi,ti))

a[7,1]<-mean(Di(ndb,tb,ndg,tg))
a[7,2]<-mean(Di(ndb,tb,ndv,tv))
a[7,3]<-mean(Di(ndb,tb,ndf,tf))
a[7,4]<-mean(Di(ndb,tb,ndx,tx))
a[7,5]<-mean(Di(ndb,tb,ndt,tt))
a[7,6]<-mean(Di(ndb,tb,ndk,tk))
a[7,8]<-mean(Di(ndb,tb,nds,ts))
a[7,9]<-mean(Di(ndb,tb,ndl,tl))
a[7,10]<-mean(Di(ndb,tb,ndi,ti))

a[8,1]<-mean(Di(nds,ts,ndg,tg))
a[8,2]<-mean(Di(nds,ts,ndv,tv))
a[8,3]<-mean(Di(nds,ts,ndf,tf))
a[8,4]<-mean(Di(nds,ts,ndx,tx))
a[8,5]<-mean(Di(nds,ts,ndt,tt))
a[8,6]<-mean(Di(nds,ts,ndk,tk))
a[8,7]<-mean(Di(nds,ts,ndb,tb))
a[8,9]<-mean(Di(nds,ts,ndl,tl))
a[8,10]<-mean(Di(nds,ts,ndi,ti))

a[9,1]<-mean(Di(ndl,tl,ndg,tg))
a[9,2]<-mean(Di(ndl,tl,ndv,tv))
a[9,3]<-mean(Di(ndl,tl,ndf,tf))
a[9,4]<-mean(Di(ndl,tl,ndx,tx))
a[9,5]<-mean(Di(ndl,tl,ndt,tt))
a[9,6]<-mean(Di(ndl,tl,ndk,tk))
a[9,7]<-mean(Di(ndl,tl,ndb,tb))
a[9,8]<-mean(Di(ndl,tl,nds,ts))
a[9,10]<-mean(Di(ndl,tl,ndi,ti))

a[10,1]<-mean(Di(ndi,ti,ndg,tg))
a[10,2]<-mean(Di(ndi,ti,ndv,tv))
a[10,3]<-mean(Di(ndi,ti,ndf,tf))
a[10,4]<-mean(Di(ndi,ti,ndx,tx))
a[10,5]<-mean(Di(ndi,ti,ndt,tt))
a[10,6]<-mean(Di(ndi,ti,ndk,tk))
a[10,7]<-mean(Di(ndi,ti,ndb,tb))
a[10,8]<-mean(Di(ndi,ti,nds,ts))
a[10,9]<-mean(Di(ndi,ti,ndl,tl))


#com a matriz completa podemos calcular a diversidade

diversity(a)

a

